# SdFat: Sd2Card Class Reference

Sd2Card Class Reference

Raw access to SD and SDHC flash memory cards. More...

`#include <Sd2Card.h>`

## Public Member Functions

bool | begin (uint8_t chipSelectPin=SD_CHIP_SELECT_PIN, uint8_t sckDivisor=SPI_FULL_SPEED)
uint32_t | cardSize ()
bool | erase (uint32_t firstBlock, uint32_t lastBlock)
bool | eraseSingleBlockEnable ()
void | error (uint8_t code)
int | errorCode () const
int | errorData () const
bool | init (uint8_t sckDivisor=SPI_FULL_SPEED, uint8_t chipSelectPin=SD_CHIP_SELECT_PIN)
bool | isBusy ()
bool | readBlock (uint32_t block, uint8_t *dst)
bool | readCID (cid_t *cid)
bool | readCSD (csd_t *csd)
bool | readData (uint8_t *dst)
bool | readStart (uint32_t blockNumber)
bool | readStop ()
uint8_t | sckDivisor ()
| Sd2Card ()
int | type () const
bool | writeBlock (uint32_t blockNumber, const uint8_t *src)
bool | writeData (const uint8_t *src)
bool | writeStart (uint32_t blockNumber, uint32_t eraseCount)
bool | writeStop ()

## Detailed Description

Raw access to SD and SDHC flash memory cards.

## Constructor & Destructor Documentation

Sd2Card::Sd2Card | ( |  | ) |

inline

Construct an instance of Sd2Card.

## Member Function Documentation

bool Sd2Card::begin | ( | uint8_t | chipSelectPin = `SD_CHIP_SELECT_PIN`,
|  | uint8_t | sckDivisor = `SPI_FULL_SPEED`
| ) |  |

Initialize an SD flash memory card.

Parameters

  [in] | chipSelectPin | SD chip select pin number.
  [in] | sckDivisor | SPI SCK clock rate divisor.

Returns
  The value one, true, is returned for success and the value zero, false, is returned for failure. The reason for failure can be determined by calling errorCode() and errorData().

uint32_t Sd2Card::cardSize | ( |  | ) |

Determine the size of an SD flash memory card.

Returns
  The number of 512 byte data blocks in the card or zero if an error occurs.

bool Sd2Card::erase | ( | uint32_t | firstBlock,
|  | uint32_t | lastBlock
| ) |  |

Erase a range of blocks.

Parameters

  [in] | firstBlock | The address of the first block in the range.
  [in] | lastBlock | The address of the last block in the range.

Note
  This function requests the SD card to do a flash erase for a range of blocks. The data on the card after an erase operation is either 0 or 1, depends on the card vendor. The card must support single block erase.

Returns
  The value one, true, is returned for success and the value zero, false, is returned for failure.

bool Sd2Card::eraseSingleBlockEnable | ( |  | ) |

Determine if card supports single block erase.

Returns
  The value one, true, is returned if single block erase is supported. The value zero, false, is returned if single block erase is not supported.

void Sd2Card::error | ( | uint8_t | code | ) |

inline

Set SD error code.

Parameters

  [in] | code | value for error code.

int Sd2Card::errorCode | ( |  | ) | const

inline

Returns
  error code for last error. See Sd2Card.h for a list of error codes.

int Sd2Card::errorData | ( |  | ) | const

inline

Returns
  error data for last error.

bool Sd2Card::init | ( | uint8_t | sckDivisor = `SPI_FULL_SPEED`,
|  | uint8_t | chipSelectPin = `SD_CHIP_SELECT_PIN`
| ) |  |

inline

Initialize an SD flash memory card.

Parameters

  [in] | chipSelectPin | SD chip select pin number.
  [in] | sckDivisor | SPI SCK clock rate divisor.

Returns
  The value one, true, is returned for success and the value zero, false, is returned for failure. The reason for failure can be determined by calling errorCode() and errorData().

bool Sd2Card::isBusy | ( |  | ) |

Check for busy. MISO low indicates the card is busy.

Returns
  true if busy else false.

bool Sd2Card::readBlock | ( | uint32_t | blockNumber,
|  | uint8_t * | dst
| ) |  |

Read a 512 byte block from an SD card.

Parameters

  [in] | blockNumber | Logical block to be read.
  [out] | dst | Pointer to the location that will receive the data.

Returns
  The value one, true, is returned for success and the value zero, false, is returned for failure.

bool Sd2Card::readCID | ( | cid_t * | cid | ) |

inline

Read a card's CID register. The CID contains card identification information such as Manufacturer ID, Product name, Product serial number and Manufacturing date.

Parameters

  [out] | cid | pointer to area for returned data.

Returns
  true for success or false for failure.

bool Sd2Card::readCSD | ( | csd_t * | csd | ) |

inline

Read a card's CSD register. The CSD contains Card-Specific Data that provides information regarding access to the card's contents.

Parameters

  [out] | csd | pointer to area for returned data.

Returns
  true for success or false for failure.

bool Sd2Card::readData | ( | uint8_t * | dst | ) |

Read one data block in a multiple block read sequence

Parameters

  [in] | dst | Pointer to the location for the data to be read.

Returns
  The value one, true, is returned for success and the value zero, false, is returned for failure.

bool Sd2Card::readStart | ( | uint32_t | blockNumber | ) |

Start a read multiple blocks sequence.

Parameters

  [in] | blockNumber | Address of first block in sequence.

Note
  This function is used with readData() and readStop() for optimized multiple block reads. SPI chipSelect must be low for the entire sequence.

Returns
  The value one, true, is returned for success and the value zero, false, is returned for failure.

bool Sd2Card::readStop | ( |  | ) |

End a read multiple blocks sequence.

Returns
  The value one, true, is returned for success and the value zero, false, is returned for failure.

uint8_t Sd2Card::sckDivisor | ( |  | ) |

inline

Return SCK divisor.

Returns
  Requested SCK divisor.

int Sd2Card::type | ( |  | ) | const

inline

Return the card type: SD V1, SD V2 or SDHC

Returns
  0 - SD V1, 1 - SD V2, or 3 - SDHC.

bool Sd2Card::writeBlock | ( | uint32_t | blockNumber,
|  | const uint8_t * | src
| ) |  |

Writes a 512 byte block to an SD card.

Parameters

  [in] | blockNumber | Logical block to be written.
  [in] | src | Pointer to the location of the data to be written.

Returns
  The value one, true, is returned for success and the value zero, false, is returned for failure.

bool Sd2Card::writeData | ( | const uint8_t * | src | ) |

Write one data block in a multiple block write sequence

Parameters

  [in] | src | Pointer to the location of the data to be written.

Returns
  The value one, true, is returned for success and the value zero, false, is returned for failure.

bool Sd2Card::writeStart | ( | uint32_t | blockNumber,
|  | uint32_t | eraseCount
| ) |  |

Start a write multiple blocks sequence.

Parameters

  [in] | blockNumber | Address of first block in sequence.
  [in] | eraseCount | The number of blocks to be pre-erased.

Note
  This function is used with writeData() and writeStop() for optimized multiple block writes.

Returns
  The value one, true, is returned for success and the value zero, false, is returned for failure.

bool Sd2Card::writeStop | ( |  | ) |

End a write multiple blocks sequence.

Returns
  The value one, true, is returned for success and the value zero, false, is returned for failure.

The documentation for this class was generated from the following files:

- Arduino/libraries/SdFat/Sd2Card.h
- Arduino/libraries/SdFat/Sd2Card.cpp